

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag
     variable Base
     variable ModuleIndex

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    if {$Base == -1}  {do_Select $ModuleIndex}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable A16Base 0x0000
    variable A24Base 0x000000
    variable A32Base 0x00000000

    variable Base -1
    variable AddrMod 0x09     ;#  A32UD
    variable DWidth  32

    variable allmodules 0
 
    for {set i 0} {$i < 16} {incr i} {variable Counter$i [expr 0x100000000 / (1+$i)]}

    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc show_variables {} {
        variable A16Base
        variable A24Base
        variable A32Base
        variable Base
        variable ShowLogFlag
        variable LogFlag
        variable JS
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules

         if {$ShowLogFlag == 1} {
             EmptyLog
             InsertLog "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base "
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "Base=$Base; ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex; "
             InsertLog "allmodules=$allmodules"
         }  else {
             if {$JS == ""} {append JS "alert(\""}
             append JS "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base; "
             append JS "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; "
             append JS "Base=$Base; ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex; "
             append JS "allmodules=$allmodules"
         }
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex
        variable A16Base
        variable A24Base
        variable A32Base
        variable Base
        variable ModuleAddress

         set ModuleIndex $i

         set address [lindex $ModuleAddress [expr $ModuleIndex - 1]]

         set A16Base [first [split $address :]]
         set A24Base [second [split $address :]]
         set A32Base [third [split $address :]]

         set Base $A32Base

         UpdateModule
   }
 
    proc UpdateModule {} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS

        for {set i 0} {$i < 16} {incr i} {variable Counter$i}

        set address 0x10   ;#   counters
        set DWidth 32
        for {set i 0} {$i < 16} {incr i 1; incr address 4} {
            set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
            if {[first $rc] != 0} {
                if {$JS == ""} {append JS "alert(\""}
                append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                    returns rc=[first $rc]; "
                break
            }
            set Counter$i [second $rc]
        }
   }


     proc do_ClearCounters {} {
        variable ModuleIndex
        variable ModuleMenu

        variable allmodules

          set SAV $ModuleIndex
          foreach module $ModuleMenu {
              if {$allmodules == 0 && $module != $ModuleIndex} {continue}
              do_Select $module

              ClearCounters
          }
          do_Select $SAV
     }

    proc ClearCounters {} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS

        set DWidth 16
        set address 0x50   ;#  clear all counters
        set data 0

              set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
              if {[first $rc] != 0} {
                  if {$JS == ""} {append JS "alert(\""}
                  append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                      returns rc=[first $rc]; "
              }
     }

     proc do_ResetCounters {} {
        variable ModuleIndex
        variable ModuleMenu

        variable allmodules

          set SAV $ModuleIndex
          foreach module $ModuleMenu {
              if {$allmodules == 0 && $module != $ModuleIndex} {continue}
              do_Select $module

              ResetCounters
          }
          do_Select $SAV
     }

    proc ResetCounters {} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS

        set DWidth 16
        set address 0x54   ;#  reset all counters
        set data 0

              set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
              if {[first $rc] != 0} {
                  if {$JS == ""} {append JS "alert(\""}
                  append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                      returns rc=[first $rc]; "
              }
     } 

     proc do_IncCounters {} {
        variable ModuleIndex
        variable ModuleMenu

        variable allmodules

          set SAV $ModuleIndex
          foreach module $ModuleMenu {
              if {$allmodules == 0 && $module != $ModuleIndex} {continue}
              do_Select $module

              IncCounters
          }
          do_Select $SAV
     }

    proc IncCounters {} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS

        set DWidth 16
        set address 0x56   ;#  increment all counters
        set data 0

              set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
              if {[first $rc] != 0} {
                  if {$JS == ""} {append JS "alert(\""}
                  append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                      returns rc=[first $rc]; "
              }
     } 


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLMODULES  {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   ADDRESS  {
                         switch [lindex $w 1] {
                             A16   {variable A16Base; set A16Base [lindex $w 2]; InsertLog "A16 Base = $A16Base"}
                             A24   {variable A24Base; set A24Base [lindex $w 2]; InsertLog "A24 Base = $A24Base"}
                             A32   {variable A32Base; set A32Base [lindex $w 2]; InsertLog "A32 Base = $A32Base"}
                         }
                         variable Base; set Base $A32Base
                   }

                   CLR    {do_ClearCounters}
                   RST    {do_ResetCounters}
                   INC    {do_IncCounters}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

