

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag
     variable Base
     variable ModuleIndex

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    if {$Base == -1}  {do_Select $ModuleIndex}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable A16Base 0x0000
    variable A24Base 0x000000
    variable A32Base 0x00000000

    variable Base -1
    variable AddrMod 0x09     ;#  A32UD
    variable DWidth  32

    variable AcqMode 0
    variable AutoReset 0
    variable DataFormat 0
    variable allcounters 0
    variable allmodules 0
    variable DwellTime 0x80000000

    variable OperationMode 0
    variable Enables -1
    for {set i 0} {$i < 32} {incr i} {variable Enable$i 1}
    for {set i 0} {$i < 32} {incr i} {variable Counter$i [expr 0x100000000 / (1+$i)]}

    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc show_variables {} {
        variable A16Base
        variable A24Base
        variable A32Base
        variable Base
        variable ShowLogFlag
        variable LogFlag
        variable JS
        variable ModuleIndex
        variable ModuleMenu
        variable allcounters
        variable allmodules

         if {$ShowLogFlag == 1} {
             EmptyLog
             InsertLog "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base "
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "Base=$Base; ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex; "
             InsertLog "allcounters=$allcounters; allmodules=$allmodules"
         }  else {
             if {$JS == ""} {append JS "alert(\""}
             append JS "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base; "
             append JS "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; "
             append JS "Base=$Base; ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex; "
             append JS "allcounters=$allcounters; allmodules=$allmodules"
         }
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex
        variable A16Base
        variable A24Base
        variable A32Base
        variable Base
        variable ModuleAddress

         set ModuleIndex $i

         set address [lindex $ModuleAddress [expr $ModuleIndex - 1]]

         set A16Base [first [split $address :]]
         set A24Base [second [split $address :]]
         set A32Base [third [split $address :]]

         set Base $A32Base

         UpdateModule
   }
 
    proc UpdateModule {} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS

        variable AcqMode
        variable AutoReset
        variable DataFormat
        variable DwellTime

        variable OperationMode
        variable Enables
        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Counter$i}

        set address 0x1104     ;#  Dwell Time
        set DWidth 32
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        if {[first $rc] != 0} {
             if {$JS == ""} {append JS "alert(\""}
             append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                 returns rc=[first $rc]; "
        } else {
            set vl [second $rc]
            set DwellTime $vl
        }

        set address 0x1108     ;#  Control 
        set DWidth 16
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        if {[first $rc] != 0} {
             if {$JS == ""} {append JS "alert(\""}
             append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                 returns rc=[first $rc]; "
        } else {
            set vl [second $rc]
            set OperationMode $vl
            set AcqMode [expr $vl & 3]
            set AutoReset [expr $vl >> 7 & 1]
            set DataFormat [expr $vl >> 1 & 1]
        }

        set address 0x1000   ;#   counters
        set DWidth 32
        for {set i 0} {$i < 32} {incr i 1; incr address 4} {
            set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
            if {[first $rc] != 0} {
                if {$JS == ""} {append JS "alert(\""}
                append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                    returns rc=[first $rc]; "
                break
            }
            set Counter$i [second $rc]
        }

        set address 0x1100     ;#  Enables
        set DWidth 32
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        if {[first $rc] != 0} {
             if {$JS == ""} {append JS "alert(\""}
             append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                 returns rc=[first $rc]; "
        } else {
            set vl [second $rc]
            set Enables $vl
            for {set i 0} {$i < 32} {incr i 1} {
                set Enable$i [expr ($Enables >> $i) & 1]
            }
        }

   }

    proc do_SetOperationMode {w v} {
        variable Base
        variable AddrMod
        variable DWidth
        variable ModuleIndex
        variable ModuleMenu
        variable JS

        variable allmodules

       switch $w {
           ACQ0      {set data 0x01}
           ACQ1      {set data 0x02}
           AUTORESET {set data 0x80}
           DATAFMT   {set data 0x04}
       }

       switch $v {
          0         {set address 0x110a}   ;#  Bit_Set
          1         {set address 0x110c}   ;#  Bit_Clear
       }

        set DWidth 16

          set SAV $ModuleIndex
          foreach module $ModuleMenu {
              if {$allmodules == 0 && $module != $ModuleIndex} {continue}
              do_Select $module
              set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
              if {[first $rc] != 0} {
                 if {$JS == ""} {append JS "alert(\""}
                 append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                     returns rc=[first $rc]; "
              } 
          }
          do_Select $SAV

    }

    proc do_OperationMode {v} {
        variable Base
        variable AddrMod
        variable DWidth
        variable ModuleIndex
        variable ModuleMenu
        variable JS

       set address 0x1108   ;#  control
       set DWidth 16
       set data $v
       set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
       if {[first $rc] != 0} {
           if {$JS == ""} {append JS "alert(\""}
           append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
               returns rc=[first $rc]; "
       } 
    }

     proc do_SetDwellTime {vl} {
        variable ModuleIndex
        variable ModuleMenu

        variable allmodules

          set SAV $ModuleIndex
          foreach module $ModuleMenu {
              if {$allmodules == 0 && $module != $ModuleIndex} {continue}
              do_Select $module

              do_DwellTime $vl
          }
          do_Select $SAV
     }

    proc do_DwellTime {v} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS
        variable DwellTime

        set DWidth 32
        set address 0x1104   ;# dwell time
        set data $v

              set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
              if {[first $rc] != 0} {
                  if {$JS == ""} {append JS "alert(\""}
                  append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                      returns rc=[first $rc]; "
              } else {
                 InsertLog "V830: Set Dwell Time = $vl"
                 set DwellTime $vl
              }

     }

     proc do_Enables {v} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS
        variable Enables

        set DWidth 32
        set address 0x1100  ;# Enables
        set data $v

        set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
        if {[first $rc] != 0} {
            if {$JS == ""} {append JS "alert(\""}
            append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
               returns rc=[first $rc]; "
        } else {
            set Enables $data
        }
     }

     proc do_SetEnable {j vl} {
        variable ModuleIndex
        variable ModuleMenu

        variable allmodules
        variable allcounters

        for {set i 0} {$i < 32} {incr i} {variable Enable$i}

        set SAV $ModuleIndex
        foreach module $ModuleMenu {
          if {$allmodules == 0 && $module != $ModuleIndex} {continue}
          do_Select $module

          for {set i 0} {$i < 32} {incr i 1} {
             if {$allcounters == 0 && $j != $i} {continue}

             set Enable$i $vl
             set enables 0
             for {set k 0} {$k < 32} {incr k 1} {
                   if {[set Enable$k] == 1} {set enables [expr $enables + (1 << $k)]}
             }

             do_Enables $enables
          }
        }
        do_Select $SAV
     }

    proc do_Save {} {
        variable ::VMEConfig::ConfigBase
        variable JS
        variable Base
        variable ModuleIndex
        variable ModuleMenu

        variable OperationMode
        variable DwellTime
        variable Enables

        set SaveFile [file join $ConfigBase V830.dat]

        set z [catch {open $SaveFile w} file]
        if {$z != 0} {
            if {$JS == ""} {append JS "alert(\""}
            append JS "Unable to access $SaveFile"
            InsertLog "[set file]"
            return
        }

        set SAV $ModuleIndex
        foreach module $ModuleMenu {
           do_Select $module
           InsertLog "Saving Settings for CAEN V830 modules"

           puts $file "$module OperationMode $OperationMode"
           puts $file "$module DwellTime $DwellTime"
           puts $file "$module Enables $Enables"

        }
        do_Select $SAV

        close $file

        InsertLog "Done"

        Elog INFORMATION "Settings for CAEN V830 modules updated in $SaveFile"
    }

    proc do_Restore {} {
        variable ::VMEConfig::ConfigBase
        variable JS
        variable Base
        variable ModuleIndex

        InsertLog "Restoring Settings for CAEN V830 modules"

        set SaveFile [file join $ConfigBase V830.dat]

        set z [catch {open $SaveFile r} file]
        if {$z != 0} {
            if {$JS == ""} {append JS "alert(\""}
            append JS "Unable to access $SaveFile"
            InsertLog "[set file]"
            return
        }

        set SAV $ModuleIndex
        foreach item [split [read $file] \n] {
            if {[string length $item] == 0} {continue}
            set m [first $item]
            if {$m != $ModuleIndex} {do_Select $m}
            set p [second $item]
            set vl [third $item]
            switch -glob $p {
                OperationMode   {do_OperationMode $vl}
                DwellTime       {do_DwellTime $vl}
                Enables         {do_Enables $vl}
            }
        }
        do_Select $SAV

        close $file

        InsertLog "Done"

        Elog INFORMATION "Settings for CAEN V830 modules restored from $SaveFile"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLCOUNTERS {variable allcounters; set allcounters [expr ($allcounters + 1) & 1]}
                   ALLMODULES  {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   ADDRESS  {
                         switch [lindex $w 1] {
                             A16   {variable A16Base; set A16Base [lindex $w 2]; InsertLog "A16 Base = $A16Base"}
                             A24   {variable A24Base; set A24Base [lindex $w 2]; InsertLog "A24 Base = $A24Base"}
                             A32   {variable A32Base; set A32Base [lindex $w 2]; InsertLog "A32 Base = $A32Base"}
                         }
                         variable Base; set Base $A32Base
                   }

                   OFFSET  {
                       set i [lindex $w 1]
                       if {$i < 32} {}
                       if {$i == 32} {do_SetDwellTime [lindex $w 2]}
                   }

                   ENABLE  {UpdateModule; do_SetEnable [lindex $w 1] [lindex $w 2]}

                   ACQMODE    {
                       switch [lindex $w 1] {
                          0   {do_SetOperationMode ACQ0 0; do_SetOperationMode ACQ1 0}
                          1   {do_SetOperationMode ACQ0 1; do_SetOperationMode ACQ1 0}
                          2   {do_SetOperationMode ACQ0 0; do_SetOperationMode ACQ1 1}
                       }
                   }
                   AUTORESET  {do_SetOperationMode AUTORESET [lindex $w 1]}
                   DATAFMT    {do_SetOperationMode DATAFMT [lindex $w 1]}

                   SAVE      {UpdateModule; do_Save}
                   RESTORE   {do_Restore}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

